'The windows/linux map editor for Quest for a King
'by SJ Zero

'$include:'omalib.bi'
CONST Tilesize = 40
omaSDL_Init ()
SDL_WM_SetCaption "DJRPG Role Playing Game Development Kit",0
CONST cButtonPressed = 1, ButtonHeld = 2

Type RadioBox
   X as Integer
   Y as Integer
   
   Active as Integer Ptr
end Type


Type InputBoxType
   X as integer
   Y as integer
   w as INTEGER
   h AS INTEGER
   
   Value as String ptr

   Active as Integer
   
end type

   
Type INTMonitorType
   Value as integer ptr
   maxlen as integer
   X as integer
   Y as integer
end type
TYPE STRMonitorType
   Value AS STRING PTR
   maxlen as integer
   X as integer
   Y as Integer
end type


type buttonType
   Text as string
   X as integer
   Y as Integer
   w as integer
   h as integer
   
   outerR as integer
   outerG as integer
   outerB as integer
   innerR as integer
   innerG as integer
   innerB as integer
   textR as integer
   textG as integer
   textB as integer
end type
type ScrollBarType
   X as integer
   Y as Integer
   w as integer
   h as integer
   
   outerR as integer
   outerG as integer
   outerB as integer
   innerR as integer
   innerG as integer
   innerB as integer
   
   ScrollButton as ButtonType
   value as integer ptr
   maxValue as integer
   
end type

'**************DECLARATIONS********************

DECLARE SUB UserObjectSelect (Spriteno as integer)
declare sub RightClickMenu (context as integer, object as integer)

declare function QuestionBox (Question as string) as integer
declare Function STRDialogBox (Text as string, boxType) as String
declare FUNCTION INTDialogBox (Text as string, BoxType) as Integer
   
DECLARE SUB DrawAll()
declare sub MapSpaceMouseControls ()
declare sub InputBoxRender (box as InputBoxType)
Declare sub ButtonRender (Button as ButtonType)
declare sub ScrollbarRender (bar as ScrollBarType)
DECLARE SUB StrMonitorRender (monitor as strMonitorType)
DECLARE SUB IntMonitorRender (monitor as intMonitorType)



declare sub setInputBox (box as InputBoxType, x, y, w, h, byref text as STRING)
declare sub setButton (button as buttontype, x, y, w, h, text as string)
declare sub setScrollBar (bar as ScrollBarType, x,y,w,h,byref value as integer, maxvalue)
declare sub setINTMonitor(monitor as INTMonitorType, x, y, byref value as integer)
DECLARE SUB setSTRMonitor(monitor as STRMonitorType, x, y, byref value as STRING)

declare function InputBoxPressed (box as InputBoxType) as integer
Declare Function ButtonPressed (Button as buttonType) as integer
declare function GetSingleKey as integer
declare function ggetkey$
DECLARE SUB ScrollBarPressed (bar as ScrollBarType)

declare sub fileread (file)
declare sub SaveMap(Filename$)
const MapTile = 1, ObjectTile = 2

'Mouse coordinates and buttons

'The game sprites.
dim shared BackBitmap as SDL_Surface ptr
dim shared SpriteBitmap as SDL_Surface ptr

'Loading the game sprites(There's no reason not to)
BackBitmap = omaLoadMaskedGraphic ("data/back2x.bmp")
SpriteBitmap = omaLoadMaskedGraphic ("data/spr2x.bmp")

'The map.
dim shared map(0 to 170,0 to 170) as integer
DIM SHARED objects(-255. TO 255, 1 TO 10) AS INTEGER
dim shared PvPVarX as integer
dim shared PvPVarY as Integer
dim shared MaxMapX as integer
dim shared MaxMapY as Integer
dim shared CSO as integer
dim Shared UserObject as Integer

PvPVary = TILESIZE
PvPVarX = TILESIZE
'FIXME: Take this stupid thing out!!
fileread 16

'Declare Buttons
'These aren't shared because they're passed directly to ButtonPressed.
dim QuitButton as buttonType
dim Loadbutton as buttonType
dim SaveButton as buttonType
DIM NewButton as buttonType
dim ScrollDown as buttonType
dim ScrollUp as buttonType
dim ScrollLeft as buttonType
dim ScrollRight as buttonType
dim SnapButton as buttonType
dim objectup as buttonType
dim objectdown as buttonType
dim spriteUp as buttonType
dim SpriteDown as buttonType

Dim ScrollBarX as scrollBarType
dim ScrollBarY as ScrollBarType

DIM PvPVarXMonitor as INTMonitorType
DIM PvPVarYMonitor AS INTMonitorType
DIM PVPVarXLabel AS STRMonitorType
DIM PvPVarYLabel AS STRMonitorType

dim shared snapActive

dim pvpvarxname as string
dim pvpvaryname as string

DIM SelectedLabel AS STRING
dim SelectedContentString as String
dim SelectedLBL as STRMonitorType
dim shared SelectedMonitor as InputBoxType
SelectedLabel = "Object:"
setSTRMonitor SelectedLbl, 500, 40, SelectedLaBeL

setInputBox SelectedMonitor, 550, 40, 15, 50, SelectedContentString

dim MajorXLabel as STRING
dim MajorXLBL as STRMonitorType
dim shared MajorXMonitor as INTMonitorType
MajorXLabel = "MajorX:"
setSTRMonitor MajorXLbl, 500, 60, MajorXLabel 

dim MajorYLabel as STRING
dim MajorYLBL as STRMonitorType
dim shared MajorYMonitor as INTMonitorType
MajorYLabel = "MajorY:"
setSTRMonitor MajorYLbl, 500, 80, MajorYLabel 

dim MinorXLabel as String
dim MinorXLBL as STRMonitorType
dim shared MinorXMonitor as INTMonitorType
MinorXLabel = "MinorX:"
setSTRMonitor MinorXLbl, 500, 100, MinorXLabel 

dim MinorYLabel as String
dim MinorYLBL as STRMonitorType
dim shared MinorYMonitor as INTMonitorType
MinorYLabel = "MinorY:"
setSTRMonitor MinorYLbl, 500, 120, MinorYLabel 

dim SpriteLabel as String
dim SpriteContentString as STRING
dim SpriteLBL as STRMonitorType
dim shared SpriteMonitor as InputBoxType
SpriteLabel = "Sprite:"
setSTRMonitor SpriteLbl, 500, 140, SpriteLabel 
SpriteContentString = "0"
setInputBox SpriteMonitor, 550, 140, 15, 50, SpriteContentString


dim ScriptLabel as STRING
dim ScriptcontentString as STRING
dim ScriptLBL as STRMonitorType
dim shared ScriptMonitor as InputBoxType
ScriptLabel = "Script:"
setSTRMonitor ScriptLbl, 500, 160, ScriptLabel 
setInputBox ScriptMonitor, 550, 140, 15, 50, ScriptContentString

dim BehaviourLabel as STRING
dim BehaviourLBL as STRMonitorType
dim BehaviourContentString AS STRING
dim shared BehaviourMonitor as InputBoxType
BehaviourLabel = "AI Type:"
setSTRMonitor BehaviourLbl, 500, 180, BehaviourLabel 

setInputBox BehaviourMonitor, 550, 140, 15, 50, BehaviourContentString

pvpvarxname = "PvPVarX"
pvpvaryname = "PvPVarY"
'x,y,sprite,Xminor,Yminor,Script,Behaviour,
'tempdirection, templength, constsprite
setSTRMonitor PvPVarXLabel, 50, 25, pvpvarxname$
setINTMonitor PvPVarXMonitor, 100, 25, PvPVarX
setSTRMonitor PvPVarYLabel, 150, 25, pvpvaryname$
setINTMonitor PvPVarYMonitor, 200, 25, PvPVarY

setbutton ObjectUp, 600,40,20,15, "< "
setButton ObjectDown, 620,40,20,15," >"
setButton SpriteUp,600,140,20,15,"<  "
setButton SpriteDown,620,140,20,15,"  >"

setButton snapButton, 20,460,150,20, "Toggle Snap"
setButton NewButton, 50, 1, 40, 20, "New"
setButton SaveButton, 100, 1, 40, 20, "Save"
setButton LoadButton, 150, 1, 40, 20, "Load"
setButton QuitButton, 200, 1, 40, 20, "Quit"
setButton ScrollUp, 10, 38, 15,15, "^"
setButton ScrollDown, 10, 420, 15, 15, "v"
setButton ScrollLeft, 30, 444, 15, 15, "<"
SetButton ScrollRight, 415, 444, 15, 15, ">"

UserObjectSelect 1

maxmapy *= TILESIZE 
maxmapx *= TILESIZE 

setScrollBar ScrollBarY, 10, 53, 15, (400 - 35),  PvPVary, maxmapy
setScrollBar ScrollBarX, 45, 444, (400 - 30), 15, PvPVarx, maxmapx


dim Rect as SDL_Rect

do
   'INPUT STUFF
   'CHECKING THE BUTTONS
   IF ButtonPressed (ScrollUp) = cButtonPressed then
      PvPVary -= TILESIZE
      if PvPVary < 0 then PvPVary = 0
   end if
   if ButtonPressed (ScrollDown) = cButtonPressed then
      PvPVary += TILESIZE
      if PvPVary > maxmapy then PvPVarY = maxmapy
   end if
   If ButtonPressed (ScrollLeft) = cButtonPressed then
      PvPVarX -= TILESIZE
      if PvPVarX < 0 then PvPVarX = 0
   end if
   If ButtonPressed (ScrollRight) = cButtonPressed then
      PvPVarX += TILESIZE
      if PvPVarX > maxmapX then PvPVarX = maxmapX
   end if
   if ButtonPressed (NewButton) = cButtonPressed then
      if INTDialogBox ("Are you sure?!", 1) then
            for a = 1 to 170
               for b = 1 to 170
                  map(a,b) = 0
               next b
            next a
            
      end if
      
   end if
   
   if ButtonPressed (SaveButton) = cButtonPressed then 
      
   end if
   if ButtonPressed (LoadButton) = cButtonPressed then
      
   end if
   if ButtonPressed (QuitButton) = cButtonPressed Then
      omaQuit
   end if
   if ButtonPressed (SnapButton) = cButtonPressed then
    if SnapActive = 1 then snapActive = 0 else snapActive = 1
     snapButton.text = "Snap"
      if snapActive then SnapButton.text = "Snap *" 
   end if
   if ButtonPressed (ObjectUP) = cButtonPressed then
      UserObjectSelect UserObject - 1 
   end if
   if ButtonPressed (ObjectDown) = cButtonPressed then
      UserObjectSelect UserObject + 1
   end if
   if ButtonPressed (SpriteUp) = cButtonPressed then
      Objects(UserObject,3) -= 1
      UserObjectSelect UserObject
   end if
   if ButtonPressed (SpriteDown) = cButtonPressed then
      Objects(UserObject,3) += 1
      UserObjectSelect UserObject
   end if


   'NOW FOR ANY TEXTBOXES.
   if InputBoxPressed (SpriteMonitor) then 
      MyString$ = *(spriteMonitor.Value)
      objects(userObject,3) = val(MyString$)
   end if

   If InputBoxPressed (ScriptMonitor) Then
      MyString$ = *(scriptMonitor.Value)
      Objects(userObject,6) = val(MyString$)
   end if
   
   IF InputBoxPressed (BehaviourMonitor) then
      MyString$ = *(BehaviourMonitor.Value)
      Objects(userObject,7) = val(MyString$)
   end if
   IF InputBoxPressed (SelectedMonitor) then
      MyString$ = *(selectedMonitor.Value)
      UserObjectSelect val(MyString$)
   end if

   
   'SCROLLING THE SCROLLBARS\
   ScrollBarPressed ScrollBarX
   ScrollBarPressed ScrollBarY
   
   'CHECKING IN-MAP MOUSE CONTROLS
   MapSpaceMouseControls
   
   'DRAWING STUFF
   'Clear the screen
   '   dim Rect
   rect.x = 0
   rect.y = 0
   Rect.w = omaScreenSurface->w
   Rect.h = omaScreenSurface->h
   SDL_FillRECT omaScreenSurface, @Rect, SDL_MapRGB(omaScreenSurface->format, 212,208,200)
   

   rect.x = 450
   rect.y = 250
   Rect.w = 175
   Rect.h = 1
   SDL_FillRECT omaScreenSurface, @Rect, SDL_MapRGB(omaScreenSurface->format, 128,128,128)
 
   rect.x += 1
   rect.y += 1
   SDL_FillRECT omaScreenSurface, @Rect, SDL_MapRGB(omaScreenSurface->format, 255,255,255)

   
   'Render the Map
   Drawall()
   
   
   'DRAW THE BUTTONS
   ScrollBarRender ScrollBarY
   ScrollBarRender ScrollBarX

   ButtonRender SpriteUp
   ButtonRender SpriteDown
   ButtonRender objectUp
   ButtonRender ObjectDown
   ButtonRender snapButton
   ButtonRender NewButton
   ButtonRender SaveButton
   ButtonRender LoadButton
   ButtonRender QuitButton
   ButtonRender ScrollUp
   ButtonRender ScrollDown
   ButtonRender ScrollLeft
   ButtonRender ScrollRight
   
   
   STRMonitorRender PvPVarXLabel
   STRMonitorRender PvPVarYLabel
   STRMonitorRender SelectedLBL
   STRMonitorRender MajorXLBL
   STRMonitorRender MajorYLBL
   STRMonitorRender MinorXLBL
   STRMonitorRender MinorYLBL
   STRMonitorRender BehaviourLBL
   STRMonitorRender ScriptLBL
   STRMonitorRender SpriteLBL
   
   INTMonitorRender PvPVarXMonitor
   INTMonitorRender PvPVarYMonitor

   INTMonitorRender MajorXMonitor
   INTMonitorRender MajorYMonitor
   INTMonitorRender MinorXMonitor
   INTMonitorRender MinorYMonitor

   
   InputBoxRender spriteMonitor
   InputBoxRender SelectedMonitor
   InputBoxRender BehaviourMonitor
   InputBoxRender ScriptMonitor   
   
   
   
   
   
   omaPageFlip()
loop


sub ButtonRender (Button as ButtonType)
   dim ButtonRect1 as SDL_Rect
   dim ButtonRect2 as SDL_Rect
   
   
   ButtonRect1.x = Button.x
   ButtonRect1.y = Button.y
   ButtonRect1.w = Button.w
   ButtonRect1.h = Button.h
   
   buttonRect2.x = Button.X + 1
   ButtonRect2.y = Button.Y + 1
   ButtonRect2.w = Button.w - 3
   ButtonRect2.h = Button.h - 3
   if button.innerR < 199 then
      buttonRect1.x += 1
      ButtonRect1.y += 1
      SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, 255, 255, 255)
      
   else
      
      SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, 0, 0, 0)
      buttonRect1.w -= 1
      buttonRect1.h -= 1
   end if
   
   
   
   
   
   if button.innerR < 199 then
      buttonRect1.x -= 1
      ButtonRect1.y -= 1
      '	SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, 0, 0, 0)
      
      
      SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, button.innerR, button.innerG, button.innerB)
      SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, 0, 0, 0)
      
   else
      SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, button.outerR, button.outerG, button.outerB)
      
   end if
   
   buttonRect1.w -= 1
   buttonRect1.h -= 1
   if button.innerR >= 199 then
      SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, 255, 255, 255)
   else
      buttonrect1.x += 2
      buttonrect1.y += 2
      buttonrect1.w -= 2
      buttonrect1.h -= 2
      SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, 0, 0, 0)
      SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, button.innerR, button.innerG, button.innerB)
      
      
   end if
   
   if button.innerR < 199 then 
      ButtonRect2.x += 2
      ButtonRect2.y += 2
   end if
   
   SDL_fillRect omaScreenSurface, @ButtonRect2, SDL_MapRGB(omaScreenSurface->format, 212, 206, 201)
   
   
   
   dim clr as SDL_Color
   
   clr.r = Button.TextR
   clr.g = Button.TextG
   clr.b = Button.TextB
   dim w, h

   	TTF_SizeText omaFont, Button.text, @w, @h 

   omaPrint (button.x + (button.w/2)) - (w / 2) - (2 * (button.innerR < 199)), (button.y + (button.h/2)) - (h / 2) - (2 * (button.innerR < 199)), clr, Button.text
end sub

sub setButton (button as buttontype, x, y, w, h, text as string)
   Button.x = x 
   Button.y = y
   Button.w = w
   Button.h = h
   Button.text=text
   button.outerR = 128
   button.outerG = 128
   button.outerB = 128
   
   button.innerR = 212
   button.innerG = 208
   button.innerB = 200
end sub


Function ButtonPressed (Button as buttonType) as integer
   
   static AlmostPressed$
   static MouseNotReleased
   Static MouseNotReleasedString$
   
   if NOT (omaMouseButtons AND 1) then MouseNotReleased = 0:MouseNotReleasedString$ = ""
   
   if button.x < omaMouseX and button.x + button.w > omaMouseX AND _ 
   button.y < omaMouseY and button.y + button.h > omaMouseY then
   if (omaMouseButtons AND 1) then 
      if AlmostPressed$ <> button.text then
	 MouseNotReleased = 1
	 MouseNotReleasedString$ = button.text
	 midR = button.outerR
	 midG = button.outerG
	 midB = button.outerB
	 
	 button.outerR = button.innerR
	 button.outerG = button.innerG
	 button.outerB = button.innerB
	 
	 Button.innerR = midR
	 button.innerG = midG
	 button.innerB = midB
	 AlmostPressed$ = button.text
      end if
   else
      MouseNotReleased = 0
      if AlmostPressed$ = button.text then
	 midR = button.outerR
	 midG = button.outerG
	 midB = button.outerB
	 
	 button.outerR = button.innerR
	 button.outerG = button.innerG
	 button.outerB = button.innerB
	 
	 Button.innerR = midR
	 button.innerG = midG
	 button.innerB = midB
	 AlmostPressed$ = ""
	 return 1
      end if
   end if
   
else
   if AlmostPressed$ = button.text then
      midR = button.outerR
      midG = button.outerG
      midB = button.outerB
      
      button.outerR = button.innerR
      button.outerG = button.innerG
      button.outerB = button.innerB
      
      
      
      Button.innerR = midR
      button.innerG = midG
      button.innerB = midB
      AlmostPressed$ = ""
   end if
   
   if MouseNotReleased and MouseNotReleasedString$ = Button.Text then
      return 2
   end if
   
end if





end function

sub setScrollBar (bar as ScrollBarType, x,y,w,h,byref value as integer, maxvalue as integer)
   static BarSet$
   BarSet$ = Barset$ + " "
   bar.x = x
   bar.y = y
   bar.w = w
   bar.h = h
   bar.value = @value
   bar.maxValue = maxValue
   
   bar.outerR = 64
   bar.outerG = 64
   bar.outerB = 64
   
   bar.innerR = 128
   bar.innerG = 128
   bar.innerB = 128
   
   'THIS WILL TELL THE BUTTON HOW TO SET ITSELF DEPENDING ON WHETHER IT'S
   'HORIZONTAL OR VERTICAL. W > H if it's long, H < W if it's tall.
   if w > h then 
      buttonw = 10
      buttonh = bar.h
      
   else
      buttonw = bar.w
      buttonh = 10
      
   end if
   setButton bar.ScrollButton, x,y, buttonw, buttonh, BarSet$
   
   dim Percentage as double
   Percentage = 0! + abs((*(bar.value) / bar.maxvalue))
   
   if bar.w > bar.h then
      bar.scrollbutton.x = bar.x + ((bar.w - bar.Scrollbutton.w) * Percentage) 
   else
      bar.scrollbutton.y = bar.y + ((bar.h - bar.ScrollButton.h) * Percentage)
   end if
   
end sub
sub ScrollbarRender (bar as ScrollBarType)
   dim ButtonRect1 as SDL_Rect
   dim ButtonRect2 as SDL_Rect
   ButtonRect1.x = Bar.x
   ButtonRect1.y = Bar.y
   ButtonRect1.w = Bar.w
   ButtonRect1.h = Bar.h
   
   buttonRect2.x = Bar.X + 2
   ButtonRect2.y = Bar.Y + 1
   ButtonRect2.w = Bar.w - 4
   ButtonRect2.h = Bar.h - 1
   
   SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, Bar.outerR, Bar.outerG, Bar.outerB)
   SDL_fillRect omaScreenSurface, @ButtonRect2, SDL_MapRGB(omaScreenSurface->format, Bar.innerR, Bar.innerG, Bar.innerB)
   
   ButtonRender bar.ScrollButton
end sub

sub ScrollBarPressed (bar as ScrollBarType)
   if ButtonPressed (bar.ScrollButton) = 2 then
      dim newPercentage as double
      
      if bar.w > bar.h then
         newPercentage = omaMouseX - bar.x 'THIS IS THE RELATIVE X
         newPercentage = newPercentage / bar.w
      else
	 newPercentage = 0! + omaMouseY - bar.y 'THIS IS THE RELATIVE Y
	 newPercentage = 0! + newPercentage / bar.h
      end if
      
      if newPercentage > 1 then newPercentage = 1
      if newPercentage < 0 then newPercentage = 0
      *(bar.value) = 0! + newPercentage * bar.maxValue
      
   end if
   dim Percentage as double
   Percentage = 0! + abs((*(bar.value) / bar.maxvalue))
   
   if bar.w > bar.h then
      bar.scrollbutton.x = bar.x + ((bar.w - bar.Scrollbutton.w) * Percentage) 
   else
      bar.scrollbutton.y = bar.y + ((bar.h - bar.ScrollButton.h) * Percentage)
   end if
   
   
end sub

SUB INTMonitorRender (monitor as INTMonitorType)
   dim clr as SDL_Color
   
   dim ButtonRect1 as SDL_Rect
   dim ButtonRect2 as SDL_Rect
   ButtonRect1.x = monitor.x
   ButtonRect1.y = monitor.y
   ButtonRect1.w = (len(str$(*(monitor.value))) + 1) * 5
   
   if buttonrect1.w > monitor.maxlen then
      monitor.maxlen = buttonrect1.w
   else
      buttonrect1.w = monitor.maxlen
   end if
   
   ButtonRect1.h = 12
   
   
   
   SDL_fillRect omaScreenSurface, @ButtonRect1, SDL_MapRGB(omaScreenSurface->format, 212,208,200)
   
   
   clr.r = 0
   clr.g = 0
   clr.b = 0
   omaPrint monitor.x, monitor.y, clr, str$(*(monitor.value))
   
end sub

SUB StrMonitorRender (monitor as STRMonitorType)
   dim clr as SDL_Color
 
   clr.r = 0
   clr.g = 0
   clr.b = 0
   omaPrint monitor.x, monitor.y, clr, *(monitor.value)
end sub

sub setINTMonitor(monitor as INTMonitorType, x, y, byref value as integer)
   monitor.x = x
   monitor.y = y
   monitor.value = @value
end sub

SUB setSTRMonitor(monitor as STRMonitorType, x, y, byref value as STRING)
   
   
   
   monitor.x = x
   monitor.y = y
   monitor.value = @value
end sub
sub fileread (file)
   DIM filenum AS INTEGER
   
   filenum = FREEFILE
   
   LastFileLoaded = File
   DIM readme#(0 TO 15, 0 TO 15)
   FOR a = 0 TO 170
      FOR b = 0 TO 170
         map(a, b) = 0
      NEXT b
   NEXT a
   
   filen = FREEFILE
   
   OPEN "maps.txt" FOR INPUT AS #filen
   
   
   WHILE thestring$ <> "case " + STR$(File)
      INPUT #filen, thestring$
   WEND
   
   INPUT #filen, thestring$
   maxmapy = VAL(MID$(thestring$, 8))
   
   INPUT #filen, thestring$
   maxmapx = VAL(MID$(thestring$, 8))
   
   INPUT #filen, thestring$
   filestring$ = RTRIM$(LTRIM$(thestring$ + ".txt"))
   
   CLOSE filen
   objectstring$ = RTRIM$(LTRIM$(thestring$ + ".obf"))
   
   
   
   OPEN objectstring$ FOR INPUT AS #filen
   
   
   FOR y = -100 TO 140                          ' This little routine reads the DATA
      FOR x = 1 TO 10 'Just don't load 10, and it remains constant and scripted.
         IF x <> 10 THEN
	    INPUT #filenum, objects(y, x)
	 ELSE
	    INPUT #filenum, clonehigh
	 END IF
         
      NEXT x
   NEXT y
   
   CLOSE #filenum
   
   
   OPEN filestring$ FOR INPUT AS #filen
   
   FOR y = 1 TO maxmapy
      FOR x = 0 TO maxmapx
         INPUT #filenum, map(x, y)
         'map(x,y) += 36
         'FIXME: WE NEED REASONABLE MAP FORMATS!!!!!
      NEXT x
   NEXT y
   
   CLOSE #filenum
   
   90210
   
end sub

SUB drawall ()
   STATIC oldpvpvary
   static almost
   STATIC oldpvpvarx
   static RenderfirstX, RenderFirstY, RenderSecondX, RenderSecondY
   
   maxpar = pvpvary MOD tilesize

'THE FIRST THING WE DRAW ARE THE WINDOWS-LIKE BEVELS ON THE EDIT WINDOW.
   dim ButtonRect1 as SDL_Rect
   ButtonRect1.x = 431 
   ButtonRect1.y = 38
   ButtonRect1.w = 1
   ButtonRect1.h = 402 
   
   SDL_FillRect omaScreenSurface, @ButtonRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 255,255,255)
   
   ButtonRect1.x = 29 
   ButtonRect1.y += 1
   SDL_FillRect omaScreenSurface, @ButtonRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 128,128,128)
   
   
   SDL_FillRect omaScreenSurface, @ButtonRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 128,128,128)
   
   ButtonRect1.y = 39 
   ButtonRect1.x = 30
   ButtonRect1.h = 1
   ButtonRect1.w = 400
   
   SDL_FillRect omaScreenSurface, @ButtonRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 0,0,0)
   
   ButtonRect1.y -= 1
   SDL_FillRect omaScreenSurface, @ButtonRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 128,128,128)
   
   ButtonRect1.y = 441
   ButtonRect1.x += 1
   SDL_FillRect omaScreenSurface, @ButtonRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 255,255,255)	
   

'NOW WE CALCULATE WHAT TO RENDER AND RENDER IT.
   IF oldpvpvary <> pvpvary THEN
      RenderFirstY = pvpvary \ tilesize
      RenderSecondY = RenderFirstY + (440 \ tilesize)
   END IF
   IF oldpvpvarx <> pvpvarx THEN
      RenderFirstX = pvpvarx \ tilesize
      RenderSecondX = RenderFirstX + (440 \ tilesize)
      
   END IF
   
   
   
   
   oldpvpvarx = pvpvarx
   oldpvpvary = pvpvary
   maxpar = pvpvary MOD tilesize
   FOR x = RenderFirstX TO RenderSecondX
      multedx = (x * tilesize) - (PvPVarX)
      FOR y = RenderFirstY TO RenderSecondY
	 multedy = (y * tilesize) - (pvpVarY)
	 omaqfakBlitCulledImage 30,40,400,400,multedx  ,multedy, map(x,y)+ 36, backBitmap 
      NEXT y
   NEXT x
'THIS PUTS BLOCKS AROUND THE CURRENTLY SELECTED OBJECT.
   dim Rectangle3 as SDL_Rect
   rectangle3.x = 30
   Rectangle3.y = 40
   Rectangle3.w = 400
   Rectangle3.h = 400
   SDL_SetClipRect omaScreenSurface, @Rectangle3
 a = UserObject
	 xx = ((objects(a, 1)) * TILESIZE) + objects(a, 4) - pvpvarx + 30
	 
	 yy = ((objects(a, 2) ) * TILESIZE) + objects(a, 5) - pvpvary + 50
      dim Rect as SDL_Rect
      rect.x = xx
      rect.y = yy
      rect.w = 10
      rect.h = 10
      SDL_fillRect omaScreenSurface, @Rect, SDL_MapRGB(omaScreenSurface->format, 255, 0, 0)
      rect.x = xx + tilesize - rect.w
      SDL_fillRect omaScreenSurface, @Rect, SDL_MapRGB(omaScreenSurface->format, 255, 0, 0)
      rect.y = yy + tilesize - rect.h
      SDL_fillRect omaScreenSurface, @Rect, SDL_MapRGB(omaScreenSurface->format, 255, 0, 0)
      rect.x = xx
      SDL_fillRect omaScreenSurface, @Rect, SDL_MapRGB(omaScreenSurface->format, 255, 0, 0)

'HERE WE RESTORE THE CLIPRECT.
   SDL_SetClipRect omaScreenSurface, 0
'
   'HERE WE DRAW THE FOREGROUND TILES. NO FAST CULLING IS USED BECAUSE
   'WE DON'T CARE ABOUT SPEED.
   CSO = 0
static lastCSO
   for a = -255 to 255
      
      if objects(a,3) > 0 then
	 xx = (objects(a, 1) * TILESIZE) + objects(a, 4) - pvpvarx
	 
	 yy = (objects(a, 2) * TILESIZE) + objects(a, 5) - pvpvary
	 
	 omaqfakBlitCulledImage 30,40,400,400,xx  ,yy, objects(a,3) - 1, spriteBitmap 
	 if (omaMouseX - 30) > xx and (omaMouseX - 30) < (xx + TILESIZE) AND _
         (omaMouseY - 40) > yy AND (omaMouseY - 40) < (yy + TILESIZE) AND _
            omaMouseX > 30 and omaMouseY > 40 and omaMouseX < 430 and omaMouseY < 440 then

	 if (omaMousebuttons AND 1) = 0 then almost += 1
	 

 if (almost = 1) and ((omaMouseButtons AND 1) = 0) then UserObjectSelect(a)
	print almost
	 almost = -1

if (omaMouseButtons AND 1) then almost += 1

	 CSO = a
      
	 
      end if
      
   end if
next a

omaqfakBlitImage 450, 40, Objects(UserObject,3) - 1,SpriteBitmap
omaqfakBlitImage 450, 85, MapObject - 36, BackBitmap

  
END SUB

SUB UserObjectSelect (Spriteno as integer)
   UserObject = Spriteno


   setINTMonitor MinorYMonitor, 550, 120, objects(UserObject,5)
   setINTMonitor MinorXMonitor, 550, 100, objects(UserObject,4)
   setINTMonitor MajorYMonitor, 550, 80, objects(UserObject,2)
   setINTMonitor MajorXMonitor, 550, 60, objects(UserObject,1)

   if SpriteMonitor.active = 0 then *(SpriteMonitor.value) = str$(objects(UserObject,3))
   setInputBox SpriteMonitor, 550, 140, 50,15, *(SpriteMonitor.value)'objects(UserObject,3)

   if SelectedMonitor.active = 0 then *(SelectedMonitor.value) = str$(UserObject)
   setInputBox SelectedMonitor, 550, 40, 50,15, *(SelectedMonitor.value)'objects(UserObject,3)

   if ScriptMonitor.active = 0 then *(ScriptMonitor.value) = str$(objects(UserObject,6))
   setInputBox ScriptMonitor, 550, 160, 50,15, *(ScriptMonitor.value)'objects(UserObject,3)

   if BehaviourMonitor.active = 0 then *(BehaviourMonitor.value) = str$(objects(UserObject,7))
   setInputBox BehaviourMonitor, 550, 180, 50,15, *(BehaviourMonitor.value)'objects(UserObject,3)

end sub

SUB MapSpaceMouseControls
'IF YOU ARE NOT IN MAPSPACE, DON'T DO ANY OF THIS!!!
   Static startedDraggingOn
   static dragging
   static CurrentlyDraggedObject
   
   if cSO = 0 AND (omaMousebuttons AND 1) then
      if StartedDraggingOn <> 0 and UserObject = StartedDraggingOn then
         'THE USER IS DRAGGING A TILE
         dragging = 1
	 
      end if
      
   end if
   
   startedDraggingOn = CSO
   CurrentlyDraggedObject = USEROBJECT
   
   if dragging then
      xx = omaMouseX - 30 + pvpVarX
      yy = omaMouseY - 40 + PvPVarY
      if SnapActive then 
	 if xx mod TILESIZE < 10 then xx -= xx MOD tilesize
	 if xx MOD TILESIZE > TILESIZE - 10 then xx += TILESIZE - xx mod tilesize
	 
	 if yy mod TILESIZE < 10 then yy -= yy MOD tilesize
	 if yy MOD TILESIZE > TILESIZE - 10 then yy += TILESIZE - yy mod tilesize
      end if
      
      MajorX = xx \ TILESIZE
      MajorY = yy \ TILESIZE
      MinorX = xx MOD TILESIZE
      MinorY = yy MOD TILESIZE
      if MinorX = TILESIZE then MinorX = 0
      IF MinorY = TILESIZE then MinorY = 0
      print CurrentlyDraggedObject, xx, yy, pvpvarx, pvpvary
      objects(CurrentlyDraggedObject, 1) = MajorX
      objects(CurrentlyDraggedObject, 2) = MajorY
      objects(CurrentlyDraggedObject, 4) = MinorX
      objects(CurrentlyDraggedObject, 5) = MinorY
   end if
   
   
   
   if not (omaMousebuttons AND 1) then
      dragging = 0
   end if
   
   
   'WHAT TO DO IF YOU CLICK ON A TERRAIN TILE
   if CSO = 0 and (omaMouseButtons AND 1) and dragging = 0 then
      
   end if
   
   static waitonce
   
   
   
   if omaMouseButtons AND 4 then
      if CSO <> 0 then 
	 print "You should bring up a sprite context menu."
	 
      else
	 if omaMouseX > 30 and omaMouseX < 430 AND omaMouseY > 40 AND omaMouseY < 440 then
	    print "You should bring up a map conext menu."
	 end if
	 
      end if
   end if
   
end sub

sub setInputBox (box as InputBoxType, x, y, w, h, byref text as STRING)

	box.x = x
	box.y = y
	box.w = w
	box.h = h
	box.value = @text
	
end sub

sub InputBoxRender (box as InputBoxType)

   dim BoxRect1 as SDL_Rect
   'UPPER RIGHT CORNERS.
   BoxRect1.x = box.x  
   BoxRect1.y = box.y - 1
   BoxRect1.w = box.w 
   BoxRect1.h = box.h + 1
   

   boxrect1.w = 1
   
   SDL_FillRect omaScreenSurface, @BoxRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 0,0,0)
   
   boxRect1.x -= 1
   boxRect1.h += 1
      SDL_FillRect omaScreenSurface, @BoxRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 128,128,128)
   
   BoxRect1.x = box.x  
   BoxRect1.y = box.y
   BoxRect1.w = box.w + 2
   BoxRect1.h = box.h 
   

   boxrect1.h = 1
   
   SDL_FillRect omaScreenSurface, @BoxRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 0,0,0)
   
   boxRect1.y -= 1
      SDL_FillRect omaScreenSurface, @BoxRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 128,128,128)
   'LOWER RIGHT CORNERS
   BoxRect1.x = box.x + box.w + 1 
   BoxRect1.y = box.y - 1
   BoxRect1.w = box.w 
   BoxRect1.h = box.h + 2
   

   boxrect1.w = 1
   
   SDL_FillRect omaScreenSurface, @BoxRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 255,255,255)
   
   BoxRect1.x = box.x  
   BoxRect1.y = box.y + box.h + 1
   BoxRect1.w = box.w + 2
   BoxRect1.h = box.h 
   

   boxrect1.h = 1
   
   SDL_FillRect omaScreenSurface, @BoxRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 255,255,255)
   
   
   'INSIDE THE INPUTBOX
   
   BoxRect1.x = box.x + 1 
   BoxRect1.y = box.y + 1
   BoxRect1.w = box.w - 1
   BoxRect1.h = box.h - 1
   
   SDL_FillRect omaScreenSurface, @BoxRect1, _ 
   SDL_MapRGB(omaScreenSurface->format, 255,255,255)
   
   
   dim clr as SDL_Color
   clr.r = 0
   clr.g = 0
   clr.b = 0
   Text$ = *(box.value)
   if box.active and SDL_GetTicks MOD 1000 < 500 then Text$ = Text$ + "|"
   omaPrint box.x, box.y, clr, Text$

end sub

function GetSingleKey as integer
   static LastKey
   static LastTime

   
   dim code as integer
   
   
   for a = 300 to 0 step -1
      if a = 329 then a = 325
      if omaMultiKey (a) then code = a 
   next a
   if code = 0 then LastKey = 0:exit function
   
   
   if (LastKey <> code or LastTime < SDL_GetTicks())  then
      LastKey = code
      GetSingleKey = code
      LastTime = SDL_GetTicks() + 500
   end if
   
END function

function ggetkey$
      static oldx
      x = getsingleKey ()
      if x = 0 then ggetkey$ = "":exit function
      ggetKey$ = chr$(x AND 255)
      oldx = x
end function

function InputBoxPressed (box as InputBoxType) as integer
static OldValue$
	if omaMouseX > box.x and omaMouseX < (box.x + box.w) and _
		omaMouseY > box.y and omaMouseY < (box.y + box.h) AND _
      (omaMousebuttons AND 1) and box.active = 0 then
      OldValue$ = ""
      box.active = 1
      OldValue$ = *(box.value)
   else
      if (omaMousebuttons AND 1) and box.active = 1 then
         box.active = 0
         OldValue$ = ""
         return 1
      end if

   end if
   const xInput_Enter = chr$(13)
   Const xInput_Escape = chr$(27)   
   Const xInput_BackSpace = chr$(8)
   if box.active then
 

      MyString$ = *(box.value) 
      OtherString$ = ggetKey$
      
      select case OtherString$
         case xInput_BackSpace
            if len(MyString$) = 1 then MyString$ = " "
            if LEN(MyString$) > 1 then MyString$ = Left$(MyString$,len(MyString$) - 1)
            *(box.value)= MyString$
         Case xInput_Escape
            *(box.value)= OldValue$
            box.active = 0
            return 0
         Case xInput_Enter
            box.Active = 0
            return 1
         Case Else
            MyString$ = MyString$ + OtherString$
            MyString$ = Left$(MyString$,(box.w / 8))
            *(box.value)= MyString$
      end select
   end if

end function 
Function STRDialogBox (Text as string, boxType) as String
   dim box as SDL_Rect
   box.x = 100
   box.y = 100
   box.w = 300
   box.h = 100
   dim DialogText as StrMonitorType
   dim Rect1 as SDL_Rect
   
      dim w, h

   	TTF_SizeText omaFont, Text, @w, @h 
   setSTRMonitor DialogText, box.x + (box.w / 2) - (w / 2), box.y + 1,Text
   
   dim DialogWarning as String
   dim DialogWText as STRMonitorType
   select case boxType
   case 1
      DialogWarning = "Doing this will erase all the changes you've made!"
      dim ButtonYes as ButtonType
      dim ButtonNo as ButtonType
   setButton ButtonYes, 110,150, 130, 30, "YES"
   setButton ButtonNo, 258, 150, 130, 30, "NO"
   end select

   setSTRMonitor DialogWText, 110, 120, DialogWarning
   
   
      do
         
         'DRAWING THE BOX ITSELF
         Rect1.x = box.x 
         Rect1.y = box.y
         Rect1.w = box.w
         Rect1.h = box.h
         
         SDL_FillRect omaScreenSurface, @Rect1, _ 
         SDL_MapRGB(omaScreenSurface->format, 255,255,255)
         Rect1.x += 2
         Rect1.y += 2
         
         SDL_FillRect omaScreenSurface, @Rect1, _ 
         SDL_MapRGB(omaScreenSurface->format, 0,0,0)
         
         rect1.w -= 1
         Rect1.h -= 1
         SDL_FillRect omaScreenSurface, @Rect1, _ 
         SDL_MapRGB(omaScreenSurface->format, 128,128,128)
         
         Rect1.x -= 1
         Rect1.y -= 1
         
         SDL_FillRect omaScreenSurface, @Rect1, _ 
         SDL_MapRGB(omaScreenSurface->format, 212,208,202)
         
         Rect1.h = 20
         SDL_FillRect omaScreenSurface, @Rect1, _ 
         SDL_MapRGB(omaScreenSurface->format, 0,0,0)
         
   
         Rect1.x += 3
         Rect1.w -= 6
               SDL_FillRect omaScreenSurface, @Rect1, _ 
         SDL_MapRGB(omaScreenSurface->format, 225,225,225)
         
         'DRAWING ANY TEXT
         StrMonitorRender DialogText
         StrMonitorRender DialogWText
         
         'DOING WHATEVER CONTROLS ARE ASKED FOR
         
         select case boxType
         case 1
            Buttonrender ButtonYes
            Buttonrender ButtonNo
            if ButtonPressed (ButtonYes) then
               return "1"
            end if
            if ButtonPressed (ButtonNo) then
               return "0"
            end if
            
         end select
         
         
         omaPageFlip
      loop
      
end Function
FUNCTION INTDialogBox (Text as string, BoxType) as Integer
   INTDialogBox = val(STRDialogBox(Text, Boxtype))
end function


sub SaveMap(Filename$)
'GUESS WHAT THIS DOES. REALLY. GUESS.

   filenum = FREEFILE
   
   IF Filename$ <> "" THEN
      
      OPEN Filename$ + ".txt" FOR OUTPUT AS #filenum
      
      FOR r = 1 TO MaxMapY%    'both WERE one.                     ' This little routine reads the DATA
         PRINT #filenum, fileLin#
         FOR q = 1 TO MaxMapX%                     ' into the map array.  We will use
            PRINT #filenum, INT(map%(q, r))
            
         NEXT q
      NEXT r
      CLOSE #filenum
      
      OPEN Filename$ + ".obf" FOR OUTPUT AS #filenum
      
      
      FOR y = -100 TO 140                         ' This little routine reads the DATA
         FOR xx = 1 TO 10
            PRINT #filenum, objects(y, xx);
         NEXT xx
         
         PRINT #filenum,
      NEXT y
   END IF
   CLOSE filenum
   
   
end sub


