DEFint A-Z

DECLARE SUB putlight (xx, yy, r)
'Lighting system proof-of-concept

'by SJ Zero

'The purpose of this routine is to see if real-time lightmapping in would be
'pheasable in PureQB. This version uses only greyscale, but that's only
'because I'm too lazy to use the real palette and find 3 sets of gradients.

'The results are pretty much conclusive so far: the raytracing is fast enough
'and the lightmapping is too.

CONST tilesize = 10
DIM SHARED blockerx          AS INTEGER
DIM SHARED blockery  AS INTEGER
dim buttons as integer
DECLARE SUB lightpset ()

DIM SHARED lightmap(320, 200) AS INTEGER

DIM SHARED shades(255, 0 TO 16) AS INTEGER
      
   for b = 1 to 16
      shades(1,b) = 29 - (b * 3) 
   next b





SUB lightpset ()
   
   for a = 1 to 320
   for b = 1 to 200
      lightmap(a,b)=0
   next b
next a

'This is a testing algorithm to see if this works.

FOR b = 1 TO 200
 d& = b * 320&
 e = b 
 FOR a = 0 TO 319
  colr = 1
  IF (b >= blockery) AND (b <= (blockery + tilesize)) AND (a >= blockerx) AND (a <= (blockerx + tilesize)) THEN

   'BLOCK EVERYTHING
  ELSEIF lightmap(a, e) <= 3 THEN
   'DRAW A POINT OF LIGHT
   'pset (a,b), shades(colr,lightmap(a,e))
   END IF
 NEXT a
NEXT b


END SUB

SUB putlight (xx, yy, r)

'r = 180/3.1415
 topIntensity = (r / ((60 + r) / 60) ^ 2)

  
FOR a! = 0 TO 2 * 3.1415792 STEP 3.1415792 /360'1 / (r)
                yyy = yy 
 FOR b = 2 TO r

 x = 0! + b * COS(a!) + xx
 y = (0! + b * SIN(a!) ) + yyy

 'IF ((y > blockerx) AND (y < (blockerx + tilesize))) AND ((x > blockery) AND (x < (blockery + tilesize))) THEN
' IF x = blockerx AND (y * 3) = blockery THEN b = r: BEEP: EXIT FOR
  IF (y >= (blockery )) AND (y <= ((blockery + tilesize) )) AND (x >= blockerx) AND (x <= (blockerx + tilesize)) THEN b = r: EXIT FOR

 intensity = (lightmap(x,y) +(b)) / topIntensity
 
 intensity = (2 + lightmap(x,y) + intensity) /3'- b
 if intensity > 3 then intensity = 3
 lightmap(x,y) = intensity
 if lightmap(x,y) > 4 then lightmap(x,y) = 4
 NEXT b

NEXT a!

END SUB

